;**************************************************************************
;****	File : Ex2.asm
;****	]p@Ӥ@ PORTD  LED ۰ʥ[@{      
;**************************************************************************

			list 	p = 18F452
			include <p18F452.inc>
;					       		
TMR1_VAL	EQU		.16384			; Timer1 ]w 500ms _@ 

;********************************************************************
;****	RESET Vector @ 0x0000
;********************************************************************

			org		0x0000 		;  
 			bra		Main
;
			org		0x0008		; 
			bra		Hi_ISRs
;
;********************************************************************
;****	The Main Program start from Here !! 
;********************************************************************

			org		0x0020
Main:
			call	Init_IO
			call	Init_Timer1
;
			bsf		RCON,IPEN		; Enable Interrupt priority
			bsf		INTCON,GIEH		; Enable all High Priority Interrupt
;
Null_Loop	goto	Null_Loop		; Do loop here
;
;***********************************************************************
;****		Initial the PORTD for the output port 
;***********************************************************************
Init_IO:
			clrf	TRISD
			clrf	PORTD
			return
;***********************************************************************
;****		Initial Timer1 as a 500ms Timer 
;***********************************************************************
Init_Timer1:
			?????							; 16-bit mode , Prescaler = 1:1 , Async mode
			?????							; Use external 32768Hz crystal , Timer1 On
;
	
			movlw	(.65536-TMR1_VAL)/.256	; Calcute the MSB value for the Timer1
			movwf	TMR1H
			movlw	(.65536-TMR1_VAL)%.256	; Calcute the LSB value for the Timer1
			movwf	TMR1L
;
			?????							; Set Timer1 for high priority interrupt
			?????							; Clear Timer1 Interrupt flag
			?????							; Enable Timer1 Interrupt
;
			return

;***************************************************************************************
;****		ISRs() : _Aȵ{ 
;****
;***************************************************************************************
Hi_ISRs

			?????							; Clear Timer1 Interrupt flag
;							   		
			?????							; Calcute the MSB value for the Timer1
			?????
			?????							; Calcute the LSB value for the Timer1
			?????

			?????							; PORTD = PORTD + 1;
			retfie	FAST				 	; Return with shadow register
; 
	 	  	END					 
